% =========================================================================
%   Praktikum MATLAB/Simulink I
%   Technische Universität Darmstadt
%   IAT, FG rtm (Prof. Dr.-Ing. U. Konigorski)
%
%   Copyright (c) 2017, FG Regelungstechnik und Mechatronik,
%                       Technische Universität Darmstadt
%   All rights reserved.
%
%   Redistribution and use in source and binary forms, with or withou
%   modification, are permitted provided that the following conditions are
%   met:
%
%   1. Redistributions of source code must retain the above copyright
%      notice, this list of conditions and the following disclaimer.
%
%   2. Redistributions in binary form must reproduce the above copyright
%      notice, this list of conditions and the following disclaimer in the
%      documentation and/or other materials provided with the distribution.
%
%
%   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% =========================================================================

% Versuch 3.1
% Versuchsdurchführung 3.1.5

% Hinweis: x(k), k=0,1,2... in Differenzengleichung entspricht in
% Matlab x(k*), k* = 1,2,3,...

% Funktion zur Berechnung Differnzengleichung %

function [x, t] = DiskreteLoesung(Parameter, omega, N, T0)

    k = Parameter(1);	
    d = Parameter(2);                         
    m = Parameter(3); 
    F = Parameter(4);

    C1 = (2*m + d*T0) / (m + d*T0 + k*T0^2);                         
    C2 = -m / (m + d*T0 + k*T0^2);
    C3 = (m * T0^2) / (m + d*T0 + k*T0^2);

    t = zeros(N, 1);                         
    x = zeros(N, 1);

    t(1) = 0;                         
    t(2) = T0;
    x(1) = 0;
    x(2) = F/m * C3;

    for cnt = 3:N                         
        t(cnt) = (cnt-1) * T0;                         
        x(cnt) = C1 * x(cnt-1) + C2 * x(cnt-2) + F/m * C3 * cos(omega * cnt * T0);    
    end
end
